//
//  AppController.h
//  CattailArtNSColorDemo
//
//  Created by Theresa Ford on 10/19/08.
//  Copyright 2008 Theresa L. Ford. All rights reserved.  Visit http://www.cattail.nu
//

#import <Cocoa/Cocoa.h>
#import "CattailArtNSColor.h"
#import "GradientView.h"

@interface AppController : NSObject {

   IBOutlet NSMatrix *complementMatrix;
   IBOutlet NSMatrix *triadMatrix;
   IBOutlet NSMatrix *splitComplementMatrix;
   IBOutlet NSMatrix *tetradicMatrix;
   IBOutlet NSMatrix *analogousMatrix;
   IBOutlet NSMatrix *valueMatrix;
   IBOutlet NSMatrix *saturationMatrix;
   IBOutlet NSMatrix *chromaticMatrix;
   IBOutlet NSMatrix *flameMatrix;

	IBOutlet NSColorWell *rootColorColorWell;
	IBOutlet NSMatrix *displayFormatMatrix; // RGB, HSV, Decimal, HSL, NSColor
   IBOutlet NSMatrix *displayCalculationMatrix; // Newton, RGB
	IBOutlet GradientView *gradientView;

   CGFloat hueShift;
   CGFloat saturationShift;
   CGFloat valueShift;
   int alignment;

}

-(void)updateColors;

-(IBAction)changeRootColor:(id)sender;
-(IBAction)changeColorWell:(id)sender;
-(IBAction)changeConfiguration:(id)sender;
-(IBAction)showAboutPanel:(id)sender;

@property(readwrite, assign) CGFloat hueShift;
@property(readwrite, assign) CGFloat saturationShift;
@property(readwrite, assign) CGFloat valueShift;
@property(readwrite, assign) int alignment;


@end
